<?php
namespace PowerFlux\Files;

use PowerFlux\Configuration;
use PowerFlux\ErrorOutput;

class File {

    public static function getFile(string $type): ?string
    {
        $filepath = Configuration::getFilePath($type);

        if (file_exists($filepath) ) {
            $data = file_get_contents($filepath);
            if (strlen($data) >= 5) { //dumb check, The (string) length is more than 5, return data
                return $data;
            }
        }
        return null;
    }

    public static function saveFile(string $type, string $input): bool
    {
        $filepath = Configuration::getFilePath($type);

        if ($input) {
            $r = file_put_contents($filepath, $input);
            if ($r) {
                ErrorOutput::DEBUG("WROTE " . strval($r) . " bytes to file " . $filepath);
                return true;
            }
        }
        return false;
    }


}


