<?php
namespace PowerFlux\Files;

use PowerFlux\Configuration;
use PowerFlux\ERRORCODES;
use PowerFlux\ErrorOutput;

class FileApp extends File {

    public static function getFile($type = "app"): ?string {
        $file = Configuration::getFilePath($type);

        if (file_exists($file) ) {
            $data = file_get_contents($file);
            if (strlen($data) >= 5) { //dumb check, The (string) length is more than 5, return data
                return $data;
            }
        } else {
            //Create new file with expected keys
            $jApp["access_token"] = "";
            $jApp["query_date_from"] = "";
            $jApp["query_date_to"] = "";
            $jApp["ts_api_readings_resp"] = "";
            $jApp["ts_api_readings_lastfail"] = "";
            $jApp["ts_api_prices_resp"] = "";
            $jApp["ts_api_prices_lastfail"] = "";
            $jApp["ignore_readings"] = array();
            $jApp["ignore_prices"] = array();
            
            $j = json_encode($jApp, JSON_PRETTY_PRINT);
            self::saveFile($type, $j);
            ErrorOutput::handleError(ERRORCODES::APP_NOAPPFILE ?? ERRORCODES::UNKNOWN);
        }
        return null;
    }

}