<?php
namespace PowerFlux\Files;

use PowerFlux\Configuration;
use PowerFlux\ERRORCODES;
use PowerFlux\ErrorOutput;

class FileSettings extends File {

    public static function getFile($type = "settings"): ?string {
        $file = Configuration::getFilePath($type);

        if (file_exists($file) ) {
            $data = file_get_contents($file);
            if (strlen($data) >= 5) { //dumb check, The (string) length is more than 5, return data
                return $data;
            }
        } else {
            //Create new file with expected keys
            $jSettings["refresh_token"] = "";
            $jSettings["date_from"] = "2000-01-01";
            $jSettings["date_to"] = "";
            $jSettings["meter_id"] = "";
            $jSettings["influxdb_url"] = "";
            $jSettings["influxdb_token"] = "";
            $jSettings["influxdb_bucket"] = "";
            $jSettings["influxdb_org"] = "";

            $j = json_encode($jSettings, JSON_PRETTY_PRINT);
            self::saveFile($type, $j);
            ErrorOutput::handleError(ERRORCODES::APP_NOSETTINGS ?? ERRORCODES::UNKNOWN);
        }
        return null;
    }

}