<?php
/**
 * DBRPsService
 * PHP version 5
 *
 * @category Class
 * @package  InfluxDB2
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Influx OSS API Service
 *
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 3.3.4
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace InfluxDB2\Service;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use InfluxDB2\ApiException;
use InfluxDB2\Configuration;
use InfluxDB2\HeaderSelector;
use InfluxDB2\ObjectSerializer;

/**
 * DBRPsService Class Doc Comment
 *
 * @category Class
 * @package  InfluxDB2
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class DBRPsService
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @var HeaderSelector
     */
    protected $headerSelector;

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation deleteDBRPID
     *
     * Delete a database retention policy
     *
     * @param  string $dbrp_id The database retention policy mapping (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $org_id Specifies the organization ID of the mapping (optional)
     * @param  string $org Specifies the organization name of the mapping (optional)
     *
     * @throws \InfluxDB2\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return void
     */
    public function deleteDBRPID($dbrp_id, $zap_trace_span = null, $org_id = null, $org = null)
    {
        $this->deleteDBRPIDWithHttpInfo($dbrp_id, $zap_trace_span, $org_id, $org);
    }

    /**
     * Operation deleteDBRPIDWithHttpInfo
     *
     * Delete a database retention policy
     *
     * @param  string $dbrp_id The database retention policy mapping (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $org_id Specifies the organization ID of the mapping (optional)
     * @param  string $org Specifies the organization name of the mapping (optional)
     *
     * @throws \InfluxDB2\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function deleteDBRPIDWithHttpInfo($dbrp_id, $zap_trace_span = null, $org_id = null, $org = null)
    {
        $request = $this->deleteDBRPIDRequest($dbrp_id, $zap_trace_span, $org_id, $org);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            return [null, $statusCode, $response->getHeaders()];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 400:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\InfluxDB2\Model\Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\InfluxDB2\Model\Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation deleteDBRPIDAsync
     *
     * Delete a database retention policy
     *
     * @param  string $dbrp_id The database retention policy mapping (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $org_id Specifies the organization ID of the mapping (optional)
     * @param  string $org Specifies the organization name of the mapping (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function deleteDBRPIDAsync($dbrp_id, $zap_trace_span = null, $org_id = null, $org = null)
    {
        return $this->deleteDBRPIDAsyncWithHttpInfo($dbrp_id, $zap_trace_span, $org_id, $org)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation deleteDBRPIDAsyncWithHttpInfo
     *
     * Delete a database retention policy
     *
     * @param  string $dbrp_id The database retention policy mapping (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $org_id Specifies the organization ID of the mapping (optional)
     * @param  string $org Specifies the organization name of the mapping (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function deleteDBRPIDAsyncWithHttpInfo($dbrp_id, $zap_trace_span = null, $org_id = null, $org = null)
    {
        $returnType = '';
        $request = $this->deleteDBRPIDRequest($dbrp_id, $zap_trace_span, $org_id, $org);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    return [null, $response->getStatusCode(), $response->getHeaders()];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'deleteDBRPID'
     *
     * @param  string $dbrp_id The database retention policy mapping (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $org_id Specifies the organization ID of the mapping (optional)
     * @param  string $org Specifies the organization name of the mapping (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function deleteDBRPIDRequest($dbrp_id, $zap_trace_span = null, $org_id = null, $org = null)
    {
        // verify the required parameter 'dbrp_id' is set
        if ($dbrp_id === null || (is_array($dbrp_id) && count($dbrp_id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $dbrp_id when calling deleteDBRPID'
            );
        }

        $resourcePath = '/api/v2/dbrps/{dbrpID}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($org_id !== null) {
            $queryParams['orgID'] = ObjectSerializer::toQueryValue($org_id);
        }
        // query params
        if ($org !== null) {
            $queryParams['org'] = ObjectSerializer::toQueryValue($org);
        }
        // header params
        if ($zap_trace_span !== null) {
            $headerParams['Zap-Trace-Span'] = ObjectSerializer::toHeaderValue($zap_trace_span);
        }

        // path params
        if ($dbrp_id !== null) {
            $resourcePath = str_replace(
                '{' . 'dbrpID' . '}',
                ObjectSerializer::toPathValue($dbrp_id),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            if ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($_tempBody));
            } else {
                $httpBody = $_tempBody;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'DELETE',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation getDBRPs
     *
     * List all database retention policy mappings
     *
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $org_id Specifies the organization ID to filter on (optional)
     * @param  string $org Specifies the organization name to filter on (optional)
     * @param  string $id Specifies the mapping ID to filter on (optional)
     * @param  string $bucket_id Specifies the bucket ID to filter on (optional)
     * @param  bool $default Specifies filtering on default (optional)
     * @param  string $db Specifies the database to filter on (optional)
     * @param  string $rp Specifies the retention policy to filter on (optional)
     *
     * @throws \InfluxDB2\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \InfluxDB2\Model\DBRPs|\InfluxDB2\Model\Error|\InfluxDB2\Model\Error
     */
    public function getDBRPs($zap_trace_span = null, $org_id = null, $org = null, $id = null, $bucket_id = null, $default = null, $db = null, $rp = null)
    {
        list($response) = $this->getDBRPsWithHttpInfo($zap_trace_span, $org_id, $org, $id, $bucket_id, $default, $db, $rp);
        return $response;
    }

    /**
     * Operation getDBRPsWithHttpInfo
     *
     * List all database retention policy mappings
     *
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $org_id Specifies the organization ID to filter on (optional)
     * @param  string $org Specifies the organization name to filter on (optional)
     * @param  string $id Specifies the mapping ID to filter on (optional)
     * @param  string $bucket_id Specifies the bucket ID to filter on (optional)
     * @param  bool $default Specifies filtering on default (optional)
     * @param  string $db Specifies the database to filter on (optional)
     * @param  string $rp Specifies the retention policy to filter on (optional)
     *
     * @throws \InfluxDB2\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \InfluxDB2\Model\DBRPs|\InfluxDB2\Model\Error|\InfluxDB2\Model\Error, HTTP status code, HTTP response headers (array of strings)
     */
    public function getDBRPsWithHttpInfo($zap_trace_span = null, $org_id = null, $org = null, $id = null, $bucket_id = null, $default = null, $db = null, $rp = null)
    {
        $request = $this->getDBRPsRequest($zap_trace_span, $org_id, $org, $id, $bucket_id, $default, $db, $rp);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            switch($statusCode) {
                case 200:
                    if ('\InfluxDB2\Model\DBRPs' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\InfluxDB2\Model\DBRPs', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 400:
                    if ('\InfluxDB2\Model\Error' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\InfluxDB2\Model\Error', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                default:
                    if ('\InfluxDB2\Model\Error' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\InfluxDB2\Model\Error', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\InfluxDB2\Model\DBRPs';
            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\InfluxDB2\Model\DBRPs',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\InfluxDB2\Model\Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\InfluxDB2\Model\Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation getDBRPsAsync
     *
     * List all database retention policy mappings
     *
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $org_id Specifies the organization ID to filter on (optional)
     * @param  string $org Specifies the organization name to filter on (optional)
     * @param  string $id Specifies the mapping ID to filter on (optional)
     * @param  string $bucket_id Specifies the bucket ID to filter on (optional)
     * @param  bool $default Specifies filtering on default (optional)
     * @param  string $db Specifies the database to filter on (optional)
     * @param  string $rp Specifies the retention policy to filter on (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getDBRPsAsync($zap_trace_span = null, $org_id = null, $org = null, $id = null, $bucket_id = null, $default = null, $db = null, $rp = null)
    {
        return $this->getDBRPsAsyncWithHttpInfo($zap_trace_span, $org_id, $org, $id, $bucket_id, $default, $db, $rp)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation getDBRPsAsyncWithHttpInfo
     *
     * List all database retention policy mappings
     *
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $org_id Specifies the organization ID to filter on (optional)
     * @param  string $org Specifies the organization name to filter on (optional)
     * @param  string $id Specifies the mapping ID to filter on (optional)
     * @param  string $bucket_id Specifies the bucket ID to filter on (optional)
     * @param  bool $default Specifies filtering on default (optional)
     * @param  string $db Specifies the database to filter on (optional)
     * @param  string $rp Specifies the retention policy to filter on (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getDBRPsAsyncWithHttpInfo($zap_trace_span = null, $org_id = null, $org = null, $id = null, $bucket_id = null, $default = null, $db = null, $rp = null)
    {
        $returnType = '\InfluxDB2\Model\DBRPs';
        $request = $this->getDBRPsRequest($zap_trace_span, $org_id, $org, $id, $bucket_id, $default, $db, $rp);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'getDBRPs'
     *
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $org_id Specifies the organization ID to filter on (optional)
     * @param  string $org Specifies the organization name to filter on (optional)
     * @param  string $id Specifies the mapping ID to filter on (optional)
     * @param  string $bucket_id Specifies the bucket ID to filter on (optional)
     * @param  bool $default Specifies filtering on default (optional)
     * @param  string $db Specifies the database to filter on (optional)
     * @param  string $rp Specifies the retention policy to filter on (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function getDBRPsRequest($zap_trace_span = null, $org_id = null, $org = null, $id = null, $bucket_id = null, $default = null, $db = null, $rp = null)
    {

        $resourcePath = '/api/v2/dbrps';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($org_id !== null) {
            $queryParams['orgID'] = ObjectSerializer::toQueryValue($org_id);
        }
        // query params
        if ($org !== null) {
            $queryParams['org'] = ObjectSerializer::toQueryValue($org);
        }
        // query params
        if ($id !== null) {
            $queryParams['id'] = ObjectSerializer::toQueryValue($id);
        }
        // query params
        if ($bucket_id !== null) {
            $queryParams['bucketID'] = ObjectSerializer::toQueryValue($bucket_id);
        }
        // query params
        if ($default !== null) {
            $queryParams['default'] = ObjectSerializer::toQueryValue($default);
        }
        // query params
        if ($db !== null) {
            $queryParams['db'] = ObjectSerializer::toQueryValue($db);
        }
        // query params
        if ($rp !== null) {
            $queryParams['rp'] = ObjectSerializer::toQueryValue($rp);
        }
        // header params
        if ($zap_trace_span !== null) {
            $headerParams['Zap-Trace-Span'] = ObjectSerializer::toHeaderValue($zap_trace_span);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            if ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($_tempBody));
            } else {
                $httpBody = $_tempBody;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation getDBRPsID
     *
     * Retrieve a database retention policy mapping
     *
     * @param  string $dbrp_id The database retention policy mapping ID (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $org_id Specifies the organization ID of the mapping (optional)
     * @param  string $org Specifies the organization name of the mapping (optional)
     *
     * @throws \InfluxDB2\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \InfluxDB2\Model\DBRPGet|\InfluxDB2\Model\Error|\InfluxDB2\Model\Error
     */
    public function getDBRPsID($dbrp_id, $zap_trace_span = null, $org_id = null, $org = null)
    {
        list($response) = $this->getDBRPsIDWithHttpInfo($dbrp_id, $zap_trace_span, $org_id, $org);
        return $response;
    }

    /**
     * Operation getDBRPsIDWithHttpInfo
     *
     * Retrieve a database retention policy mapping
     *
     * @param  string $dbrp_id The database retention policy mapping ID (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $org_id Specifies the organization ID of the mapping (optional)
     * @param  string $org Specifies the organization name of the mapping (optional)
     *
     * @throws \InfluxDB2\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \InfluxDB2\Model\DBRPGet|\InfluxDB2\Model\Error|\InfluxDB2\Model\Error, HTTP status code, HTTP response headers (array of strings)
     */
    public function getDBRPsIDWithHttpInfo($dbrp_id, $zap_trace_span = null, $org_id = null, $org = null)
    {
        $request = $this->getDBRPsIDRequest($dbrp_id, $zap_trace_span, $org_id, $org);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            switch($statusCode) {
                case 200:
                    if ('\InfluxDB2\Model\DBRPGet' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\InfluxDB2\Model\DBRPGet', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 400:
                    if ('\InfluxDB2\Model\Error' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\InfluxDB2\Model\Error', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                default:
                    if ('\InfluxDB2\Model\Error' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\InfluxDB2\Model\Error', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\InfluxDB2\Model\DBRPGet';
            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\InfluxDB2\Model\DBRPGet',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\InfluxDB2\Model\Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\InfluxDB2\Model\Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation getDBRPsIDAsync
     *
     * Retrieve a database retention policy mapping
     *
     * @param  string $dbrp_id The database retention policy mapping ID (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $org_id Specifies the organization ID of the mapping (optional)
     * @param  string $org Specifies the organization name of the mapping (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getDBRPsIDAsync($dbrp_id, $zap_trace_span = null, $org_id = null, $org = null)
    {
        return $this->getDBRPsIDAsyncWithHttpInfo($dbrp_id, $zap_trace_span, $org_id, $org)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation getDBRPsIDAsyncWithHttpInfo
     *
     * Retrieve a database retention policy mapping
     *
     * @param  string $dbrp_id The database retention policy mapping ID (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $org_id Specifies the organization ID of the mapping (optional)
     * @param  string $org Specifies the organization name of the mapping (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getDBRPsIDAsyncWithHttpInfo($dbrp_id, $zap_trace_span = null, $org_id = null, $org = null)
    {
        $returnType = '\InfluxDB2\Model\DBRPGet';
        $request = $this->getDBRPsIDRequest($dbrp_id, $zap_trace_span, $org_id, $org);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'getDBRPsID'
     *
     * @param  string $dbrp_id The database retention policy mapping ID (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $org_id Specifies the organization ID of the mapping (optional)
     * @param  string $org Specifies the organization name of the mapping (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function getDBRPsIDRequest($dbrp_id, $zap_trace_span = null, $org_id = null, $org = null)
    {
        // verify the required parameter 'dbrp_id' is set
        if ($dbrp_id === null || (is_array($dbrp_id) && count($dbrp_id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $dbrp_id when calling getDBRPsID'
            );
        }

        $resourcePath = '/api/v2/dbrps/{dbrpID}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($org_id !== null) {
            $queryParams['orgID'] = ObjectSerializer::toQueryValue($org_id);
        }
        // query params
        if ($org !== null) {
            $queryParams['org'] = ObjectSerializer::toQueryValue($org);
        }
        // header params
        if ($zap_trace_span !== null) {
            $headerParams['Zap-Trace-Span'] = ObjectSerializer::toHeaderValue($zap_trace_span);
        }

        // path params
        if ($dbrp_id !== null) {
            $resourcePath = str_replace(
                '{' . 'dbrpID' . '}',
                ObjectSerializer::toPathValue($dbrp_id),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            if ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($_tempBody));
            } else {
                $httpBody = $_tempBody;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation patchDBRPID
     *
     * Update a database retention policy mapping
     *
     * @param  string $dbrp_id The database retention policy mapping. (required)
     * @param  \InfluxDB2\Model\DBRPUpdate $dbrp_update Database retention policy update to apply (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $org_id Specifies the organization ID of the mapping (optional)
     * @param  string $org Specifies the organization name of the mapping (optional)
     *
     * @throws \InfluxDB2\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \InfluxDB2\Model\DBRPGet|\InfluxDB2\Model\Error|\InfluxDB2\Model\Error|\InfluxDB2\Model\Error
     */
    public function patchDBRPID($dbrp_id, $dbrp_update, $zap_trace_span = null, $org_id = null, $org = null)
    {
        list($response) = $this->patchDBRPIDWithHttpInfo($dbrp_id, $dbrp_update, $zap_trace_span, $org_id, $org);
        return $response;
    }

    /**
     * Operation patchDBRPIDWithHttpInfo
     *
     * Update a database retention policy mapping
     *
     * @param  string $dbrp_id The database retention policy mapping. (required)
     * @param  \InfluxDB2\Model\DBRPUpdate $dbrp_update Database retention policy update to apply (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $org_id Specifies the organization ID of the mapping (optional)
     * @param  string $org Specifies the organization name of the mapping (optional)
     *
     * @throws \InfluxDB2\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \InfluxDB2\Model\DBRPGet|\InfluxDB2\Model\Error|\InfluxDB2\Model\Error|\InfluxDB2\Model\Error, HTTP status code, HTTP response headers (array of strings)
     */
    public function patchDBRPIDWithHttpInfo($dbrp_id, $dbrp_update, $zap_trace_span = null, $org_id = null, $org = null)
    {
        $request = $this->patchDBRPIDRequest($dbrp_id, $dbrp_update, $zap_trace_span, $org_id, $org);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            switch($statusCode) {
                case 200:
                    if ('\InfluxDB2\Model\DBRPGet' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\InfluxDB2\Model\DBRPGet', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 400:
                    if ('\InfluxDB2\Model\Error' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\InfluxDB2\Model\Error', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 404:
                    if ('\InfluxDB2\Model\Error' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\InfluxDB2\Model\Error', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                default:
                    if ('\InfluxDB2\Model\Error' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\InfluxDB2\Model\Error', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\InfluxDB2\Model\DBRPGet';
            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\InfluxDB2\Model\DBRPGet',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\InfluxDB2\Model\Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 404:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\InfluxDB2\Model\Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\InfluxDB2\Model\Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation patchDBRPIDAsync
     *
     * Update a database retention policy mapping
     *
     * @param  string $dbrp_id The database retention policy mapping. (required)
     * @param  \InfluxDB2\Model\DBRPUpdate $dbrp_update Database retention policy update to apply (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $org_id Specifies the organization ID of the mapping (optional)
     * @param  string $org Specifies the organization name of the mapping (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function patchDBRPIDAsync($dbrp_id, $dbrp_update, $zap_trace_span = null, $org_id = null, $org = null)
    {
        return $this->patchDBRPIDAsyncWithHttpInfo($dbrp_id, $dbrp_update, $zap_trace_span, $org_id, $org)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation patchDBRPIDAsyncWithHttpInfo
     *
     * Update a database retention policy mapping
     *
     * @param  string $dbrp_id The database retention policy mapping. (required)
     * @param  \InfluxDB2\Model\DBRPUpdate $dbrp_update Database retention policy update to apply (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $org_id Specifies the organization ID of the mapping (optional)
     * @param  string $org Specifies the organization name of the mapping (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function patchDBRPIDAsyncWithHttpInfo($dbrp_id, $dbrp_update, $zap_trace_span = null, $org_id = null, $org = null)
    {
        $returnType = '\InfluxDB2\Model\DBRPGet';
        $request = $this->patchDBRPIDRequest($dbrp_id, $dbrp_update, $zap_trace_span, $org_id, $org);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'patchDBRPID'
     *
     * @param  string $dbrp_id The database retention policy mapping. (required)
     * @param  \InfluxDB2\Model\DBRPUpdate $dbrp_update Database retention policy update to apply (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $org_id Specifies the organization ID of the mapping (optional)
     * @param  string $org Specifies the organization name of the mapping (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function patchDBRPIDRequest($dbrp_id, $dbrp_update, $zap_trace_span = null, $org_id = null, $org = null)
    {
        // verify the required parameter 'dbrp_id' is set
        if ($dbrp_id === null || (is_array($dbrp_id) && count($dbrp_id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $dbrp_id when calling patchDBRPID'
            );
        }
        // verify the required parameter 'dbrp_update' is set
        if ($dbrp_update === null || (is_array($dbrp_update) && count($dbrp_update) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $dbrp_update when calling patchDBRPID'
            );
        }

        $resourcePath = '/api/v2/dbrps/{dbrpID}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($org_id !== null) {
            $queryParams['orgID'] = ObjectSerializer::toQueryValue($org_id);
        }
        // query params
        if ($org !== null) {
            $queryParams['org'] = ObjectSerializer::toQueryValue($org);
        }
        // header params
        if ($zap_trace_span !== null) {
            $headerParams['Zap-Trace-Span'] = ObjectSerializer::toHeaderValue($zap_trace_span);
        }

        // path params
        if ($dbrp_id !== null) {
            $resourcePath = str_replace(
                '{' . 'dbrpID' . '}',
                ObjectSerializer::toPathValue($dbrp_id),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;
        if (isset($dbrp_update)) {
            $_tempBody = $dbrp_update;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            if ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($_tempBody));
            } else {
                $httpBody = $_tempBody;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'PATCH',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation postDBRP
     *
     * Add a database retention policy mapping
     *
     * @param  \InfluxDB2\Model\DBRPCreate $dbrp_create The database retention policy mapping to add (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     *
     * @throws \InfluxDB2\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \InfluxDB2\Model\DBRP|\InfluxDB2\Model\Error|\InfluxDB2\Model\Error
     */
    public function postDBRP($dbrp_create, $zap_trace_span = null)
    {
        list($response) = $this->postDBRPWithHttpInfo($dbrp_create, $zap_trace_span);
        return $response;
    }

    /**
     * Operation postDBRPWithHttpInfo
     *
     * Add a database retention policy mapping
     *
     * @param  \InfluxDB2\Model\DBRPCreate $dbrp_create The database retention policy mapping to add (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     *
     * @throws \InfluxDB2\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \InfluxDB2\Model\DBRP|\InfluxDB2\Model\Error|\InfluxDB2\Model\Error, HTTP status code, HTTP response headers (array of strings)
     */
    public function postDBRPWithHttpInfo($dbrp_create, $zap_trace_span = null)
    {
        $request = $this->postDBRPRequest($dbrp_create, $zap_trace_span);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            switch($statusCode) {
                case 201:
                    if ('\InfluxDB2\Model\DBRP' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\InfluxDB2\Model\DBRP', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 400:
                    if ('\InfluxDB2\Model\Error' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\InfluxDB2\Model\Error', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                default:
                    if ('\InfluxDB2\Model\Error' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\InfluxDB2\Model\Error', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\InfluxDB2\Model\DBRP';
            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 201:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\InfluxDB2\Model\DBRP',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\InfluxDB2\Model\Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\InfluxDB2\Model\Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation postDBRPAsync
     *
     * Add a database retention policy mapping
     *
     * @param  \InfluxDB2\Model\DBRPCreate $dbrp_create The database retention policy mapping to add (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function postDBRPAsync($dbrp_create, $zap_trace_span = null)
    {
        return $this->postDBRPAsyncWithHttpInfo($dbrp_create, $zap_trace_span)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation postDBRPAsyncWithHttpInfo
     *
     * Add a database retention policy mapping
     *
     * @param  \InfluxDB2\Model\DBRPCreate $dbrp_create The database retention policy mapping to add (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function postDBRPAsyncWithHttpInfo($dbrp_create, $zap_trace_span = null)
    {
        $returnType = '\InfluxDB2\Model\DBRP';
        $request = $this->postDBRPRequest($dbrp_create, $zap_trace_span);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'postDBRP'
     *
     * @param  \InfluxDB2\Model\DBRPCreate $dbrp_create The database retention policy mapping to add (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function postDBRPRequest($dbrp_create, $zap_trace_span = null)
    {
        // verify the required parameter 'dbrp_create' is set
        if ($dbrp_create === null || (is_array($dbrp_create) && count($dbrp_create) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $dbrp_create when calling postDBRP'
            );
        }

        $resourcePath = '/api/v2/dbrps';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // header params
        if ($zap_trace_span !== null) {
            $headerParams['Zap-Trace-Span'] = ObjectSerializer::toHeaderValue($zap_trace_span);
        }


        // body params
        $_tempBody = null;
        if (isset($dbrp_create)) {
            $_tempBody = $dbrp_create;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            if ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($_tempBody));
            } else {
                $httpBody = $_tempBody;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
