<?php
/**
 * RestoreService
 * PHP version 5
 *
 * @category Class
 * @package  InfluxDB2
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Influx OSS API Service
 *
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 3.3.4
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace InfluxDB2\Service;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use InfluxDB2\ApiException;
use InfluxDB2\Configuration;
use InfluxDB2\HeaderSelector;
use InfluxDB2\ObjectSerializer;

/**
 * RestoreService Class Doc Comment
 *
 * @category Class
 * @package  InfluxDB2
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class RestoreService
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @var HeaderSelector
     */
    protected $headerSelector;

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation postRestoreBucketMetadata
     *
     * Create a new bucket pre-seeded with shard info from a backup.
     *
     * @param  \InfluxDB2\Model\BucketMetadataManifest $bucket_metadata_manifest Metadata manifest for a bucket. (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     *
     * @throws \InfluxDB2\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \InfluxDB2\Model\RestoredBucketMappings|\InfluxDB2\Model\Error
     */
    public function postRestoreBucketMetadata($bucket_metadata_manifest, $zap_trace_span = null)
    {
        list($response) = $this->postRestoreBucketMetadataWithHttpInfo($bucket_metadata_manifest, $zap_trace_span);
        return $response;
    }

    /**
     * Operation postRestoreBucketMetadataWithHttpInfo
     *
     * Create a new bucket pre-seeded with shard info from a backup.
     *
     * @param  \InfluxDB2\Model\BucketMetadataManifest $bucket_metadata_manifest Metadata manifest for a bucket. (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     *
     * @throws \InfluxDB2\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \InfluxDB2\Model\RestoredBucketMappings|\InfluxDB2\Model\Error, HTTP status code, HTTP response headers (array of strings)
     */
    public function postRestoreBucketMetadataWithHttpInfo($bucket_metadata_manifest, $zap_trace_span = null)
    {
        $request = $this->postRestoreBucketMetadataRequest($bucket_metadata_manifest, $zap_trace_span);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            switch($statusCode) {
                case 201:
                    if ('\InfluxDB2\Model\RestoredBucketMappings' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\InfluxDB2\Model\RestoredBucketMappings', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                default:
                    if ('\InfluxDB2\Model\Error' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\InfluxDB2\Model\Error', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\InfluxDB2\Model\RestoredBucketMappings';
            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 201:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\InfluxDB2\Model\RestoredBucketMappings',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\InfluxDB2\Model\Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation postRestoreBucketMetadataAsync
     *
     * Create a new bucket pre-seeded with shard info from a backup.
     *
     * @param  \InfluxDB2\Model\BucketMetadataManifest $bucket_metadata_manifest Metadata manifest for a bucket. (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function postRestoreBucketMetadataAsync($bucket_metadata_manifest, $zap_trace_span = null)
    {
        return $this->postRestoreBucketMetadataAsyncWithHttpInfo($bucket_metadata_manifest, $zap_trace_span)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation postRestoreBucketMetadataAsyncWithHttpInfo
     *
     * Create a new bucket pre-seeded with shard info from a backup.
     *
     * @param  \InfluxDB2\Model\BucketMetadataManifest $bucket_metadata_manifest Metadata manifest for a bucket. (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function postRestoreBucketMetadataAsyncWithHttpInfo($bucket_metadata_manifest, $zap_trace_span = null)
    {
        $returnType = '\InfluxDB2\Model\RestoredBucketMappings';
        $request = $this->postRestoreBucketMetadataRequest($bucket_metadata_manifest, $zap_trace_span);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'postRestoreBucketMetadata'
     *
     * @param  \InfluxDB2\Model\BucketMetadataManifest $bucket_metadata_manifest Metadata manifest for a bucket. (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function postRestoreBucketMetadataRequest($bucket_metadata_manifest, $zap_trace_span = null)
    {
        // verify the required parameter 'bucket_metadata_manifest' is set
        if ($bucket_metadata_manifest === null || (is_array($bucket_metadata_manifest) && count($bucket_metadata_manifest) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $bucket_metadata_manifest when calling postRestoreBucketMetadata'
            );
        }

        $resourcePath = '/api/v2/restore/bucket-metadata';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // header params
        if ($zap_trace_span !== null) {
            $headerParams['Zap-Trace-Span'] = ObjectSerializer::toHeaderValue($zap_trace_span);
        }


        // body params
        $_tempBody = null;
        if (isset($bucket_metadata_manifest)) {
            $_tempBody = $bucket_metadata_manifest;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            if ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($_tempBody));
            } else {
                $httpBody = $_tempBody;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation postRestoreKV
     *
     * Overwrite the embedded KV store on the server with a backed-up snapshot.
     *
     * @param  \SplFileObject $body Full KV snapshot. (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $content_encoding When present, its value indicates to the database that compression is applied to the line-protocol body. (optional, default to 'identity')
     * @param  string $content_type content_type (optional, default to 'application/octet-stream')
     *
     * @throws \InfluxDB2\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return void
     */
    public function postRestoreKV($body, $zap_trace_span = null, $content_encoding = 'identity', $content_type = 'application/octet-stream')
    {
        $this->postRestoreKVWithHttpInfo($body, $zap_trace_span, $content_encoding, $content_type);
    }

    /**
     * Operation postRestoreKVWithHttpInfo
     *
     * Overwrite the embedded KV store on the server with a backed-up snapshot.
     *
     * @param  \SplFileObject $body Full KV snapshot. (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $content_encoding When present, its value indicates to the database that compression is applied to the line-protocol body. (optional, default to 'identity')
     * @param  string $content_type (optional, default to 'application/octet-stream')
     *
     * @throws \InfluxDB2\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function postRestoreKVWithHttpInfo($body, $zap_trace_span = null, $content_encoding = 'identity', $content_type = 'application/octet-stream')
    {
        $request = $this->postRestoreKVRequest($body, $zap_trace_span, $content_encoding, $content_type);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            return [null, $statusCode, $response->getHeaders()];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                default:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\InfluxDB2\Model\Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation postRestoreKVAsync
     *
     * Overwrite the embedded KV store on the server with a backed-up snapshot.
     *
     * @param  \SplFileObject $body Full KV snapshot. (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $content_encoding When present, its value indicates to the database that compression is applied to the line-protocol body. (optional, default to 'identity')
     * @param  string $content_type (optional, default to 'application/octet-stream')
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function postRestoreKVAsync($body, $zap_trace_span = null, $content_encoding = 'identity', $content_type = 'application/octet-stream')
    {
        return $this->postRestoreKVAsyncWithHttpInfo($body, $zap_trace_span, $content_encoding, $content_type)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation postRestoreKVAsyncWithHttpInfo
     *
     * Overwrite the embedded KV store on the server with a backed-up snapshot.
     *
     * @param  \SplFileObject $body Full KV snapshot. (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $content_encoding When present, its value indicates to the database that compression is applied to the line-protocol body. (optional, default to 'identity')
     * @param  string $content_type (optional, default to 'application/octet-stream')
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function postRestoreKVAsyncWithHttpInfo($body, $zap_trace_span = null, $content_encoding = 'identity', $content_type = 'application/octet-stream')
    {
        $returnType = '';
        $request = $this->postRestoreKVRequest($body, $zap_trace_span, $content_encoding, $content_type);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    return [null, $response->getStatusCode(), $response->getHeaders()];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'postRestoreKV'
     *
     * @param  \SplFileObject $body Full KV snapshot. (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $content_encoding When present, its value indicates to the database that compression is applied to the line-protocol body. (optional, default to 'identity')
     * @param  string $content_type (optional, default to 'application/octet-stream')
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function postRestoreKVRequest($body, $zap_trace_span = null, $content_encoding = 'identity', $content_type = 'application/octet-stream')
    {
        // verify the required parameter 'body' is set
        if ($body === null || (is_array($body) && count($body) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $body when calling postRestoreKV'
            );
        }

        $resourcePath = '/api/v2/restore/kv';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // header params
        if ($zap_trace_span !== null) {
            $headerParams['Zap-Trace-Span'] = ObjectSerializer::toHeaderValue($zap_trace_span);
        }
        // header params
        if ($content_encoding !== null) {
            $headerParams['Content-Encoding'] = ObjectSerializer::toHeaderValue($content_encoding);
        }
        // header params
        if ($content_type !== null) {
            $headerParams['Content-Type'] = ObjectSerializer::toHeaderValue($content_type);
        }


        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['text/plain']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            if ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($_tempBody));
            } else {
                $httpBody = $_tempBody;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation postRestoreSQL
     *
     * Overwrite the embedded SQL store on the server with a backed-up snapshot.
     *
     * @param  \SplFileObject $body Full SQL snapshot. (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $content_encoding When present, its value indicates to the database that compression is applied to the line-protocol body. (optional, default to 'identity')
     * @param  string $content_type content_type (optional, default to 'application/octet-stream')
     *
     * @throws \InfluxDB2\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return void
     */
    public function postRestoreSQL($body, $zap_trace_span = null, $content_encoding = 'identity', $content_type = 'application/octet-stream')
    {
        $this->postRestoreSQLWithHttpInfo($body, $zap_trace_span, $content_encoding, $content_type);
    }

    /**
     * Operation postRestoreSQLWithHttpInfo
     *
     * Overwrite the embedded SQL store on the server with a backed-up snapshot.
     *
     * @param  \SplFileObject $body Full SQL snapshot. (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $content_encoding When present, its value indicates to the database that compression is applied to the line-protocol body. (optional, default to 'identity')
     * @param  string $content_type (optional, default to 'application/octet-stream')
     *
     * @throws \InfluxDB2\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function postRestoreSQLWithHttpInfo($body, $zap_trace_span = null, $content_encoding = 'identity', $content_type = 'application/octet-stream')
    {
        $request = $this->postRestoreSQLRequest($body, $zap_trace_span, $content_encoding, $content_type);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            return [null, $statusCode, $response->getHeaders()];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                default:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\InfluxDB2\Model\Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation postRestoreSQLAsync
     *
     * Overwrite the embedded SQL store on the server with a backed-up snapshot.
     *
     * @param  \SplFileObject $body Full SQL snapshot. (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $content_encoding When present, its value indicates to the database that compression is applied to the line-protocol body. (optional, default to 'identity')
     * @param  string $content_type (optional, default to 'application/octet-stream')
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function postRestoreSQLAsync($body, $zap_trace_span = null, $content_encoding = 'identity', $content_type = 'application/octet-stream')
    {
        return $this->postRestoreSQLAsyncWithHttpInfo($body, $zap_trace_span, $content_encoding, $content_type)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation postRestoreSQLAsyncWithHttpInfo
     *
     * Overwrite the embedded SQL store on the server with a backed-up snapshot.
     *
     * @param  \SplFileObject $body Full SQL snapshot. (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $content_encoding When present, its value indicates to the database that compression is applied to the line-protocol body. (optional, default to 'identity')
     * @param  string $content_type (optional, default to 'application/octet-stream')
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function postRestoreSQLAsyncWithHttpInfo($body, $zap_trace_span = null, $content_encoding = 'identity', $content_type = 'application/octet-stream')
    {
        $returnType = '';
        $request = $this->postRestoreSQLRequest($body, $zap_trace_span, $content_encoding, $content_type);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    return [null, $response->getStatusCode(), $response->getHeaders()];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'postRestoreSQL'
     *
     * @param  \SplFileObject $body Full SQL snapshot. (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $content_encoding When present, its value indicates to the database that compression is applied to the line-protocol body. (optional, default to 'identity')
     * @param  string $content_type (optional, default to 'application/octet-stream')
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function postRestoreSQLRequest($body, $zap_trace_span = null, $content_encoding = 'identity', $content_type = 'application/octet-stream')
    {
        // verify the required parameter 'body' is set
        if ($body === null || (is_array($body) && count($body) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $body when calling postRestoreSQL'
            );
        }

        $resourcePath = '/api/v2/restore/sql';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // header params
        if ($zap_trace_span !== null) {
            $headerParams['Zap-Trace-Span'] = ObjectSerializer::toHeaderValue($zap_trace_span);
        }
        // header params
        if ($content_encoding !== null) {
            $headerParams['Content-Encoding'] = ObjectSerializer::toHeaderValue($content_encoding);
        }
        // header params
        if ($content_type !== null) {
            $headerParams['Content-Type'] = ObjectSerializer::toHeaderValue($content_type);
        }


        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['text/plain']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            if ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($_tempBody));
            } else {
                $httpBody = $_tempBody;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation postRestoreShardId
     *
     * Restore a TSM snapshot into a shard.
     *
     * @param  string $shard_id The shard ID. (required)
     * @param  \SplFileObject $body TSM snapshot. (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $content_encoding When present, its value indicates to the database that compression is applied to the line-protocol body. (optional, default to 'identity')
     * @param  string $content_type content_type (optional, default to 'application/octet-stream')
     *
     * @throws \InfluxDB2\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return void
     */
    public function postRestoreShardId($shard_id, $body, $zap_trace_span = null, $content_encoding = 'identity', $content_type = 'application/octet-stream')
    {
        $this->postRestoreShardIdWithHttpInfo($shard_id, $body, $zap_trace_span, $content_encoding, $content_type);
    }

    /**
     * Operation postRestoreShardIdWithHttpInfo
     *
     * Restore a TSM snapshot into a shard.
     *
     * @param  string $shard_id The shard ID. (required)
     * @param  \SplFileObject $body TSM snapshot. (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $content_encoding When present, its value indicates to the database that compression is applied to the line-protocol body. (optional, default to 'identity')
     * @param  string $content_type (optional, default to 'application/octet-stream')
     *
     * @throws \InfluxDB2\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function postRestoreShardIdWithHttpInfo($shard_id, $body, $zap_trace_span = null, $content_encoding = 'identity', $content_type = 'application/octet-stream')
    {
        $request = $this->postRestoreShardIdRequest($shard_id, $body, $zap_trace_span, $content_encoding, $content_type);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            return [null, $statusCode, $response->getHeaders()];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                default:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\InfluxDB2\Model\Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation postRestoreShardIdAsync
     *
     * Restore a TSM snapshot into a shard.
     *
     * @param  string $shard_id The shard ID. (required)
     * @param  \SplFileObject $body TSM snapshot. (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $content_encoding When present, its value indicates to the database that compression is applied to the line-protocol body. (optional, default to 'identity')
     * @param  string $content_type (optional, default to 'application/octet-stream')
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function postRestoreShardIdAsync($shard_id, $body, $zap_trace_span = null, $content_encoding = 'identity', $content_type = 'application/octet-stream')
    {
        return $this->postRestoreShardIdAsyncWithHttpInfo($shard_id, $body, $zap_trace_span, $content_encoding, $content_type)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation postRestoreShardIdAsyncWithHttpInfo
     *
     * Restore a TSM snapshot into a shard.
     *
     * @param  string $shard_id The shard ID. (required)
     * @param  \SplFileObject $body TSM snapshot. (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $content_encoding When present, its value indicates to the database that compression is applied to the line-protocol body. (optional, default to 'identity')
     * @param  string $content_type (optional, default to 'application/octet-stream')
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function postRestoreShardIdAsyncWithHttpInfo($shard_id, $body, $zap_trace_span = null, $content_encoding = 'identity', $content_type = 'application/octet-stream')
    {
        $returnType = '';
        $request = $this->postRestoreShardIdRequest($shard_id, $body, $zap_trace_span, $content_encoding, $content_type);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    return [null, $response->getStatusCode(), $response->getHeaders()];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'postRestoreShardId'
     *
     * @param  string $shard_id The shard ID. (required)
     * @param  \SplFileObject $body TSM snapshot. (required)
     * @param  string $zap_trace_span OpenTracing span context (optional)
     * @param  string $content_encoding When present, its value indicates to the database that compression is applied to the line-protocol body. (optional, default to 'identity')
     * @param  string $content_type (optional, default to 'application/octet-stream')
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function postRestoreShardIdRequest($shard_id, $body, $zap_trace_span = null, $content_encoding = 'identity', $content_type = 'application/octet-stream')
    {
        // verify the required parameter 'shard_id' is set
        if ($shard_id === null || (is_array($shard_id) && count($shard_id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $shard_id when calling postRestoreShardId'
            );
        }
        // verify the required parameter 'body' is set
        if ($body === null || (is_array($body) && count($body) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $body when calling postRestoreShardId'
            );
        }

        $resourcePath = '/api/v2/restore/shards/{shardID}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // header params
        if ($zap_trace_span !== null) {
            $headerParams['Zap-Trace-Span'] = ObjectSerializer::toHeaderValue($zap_trace_span);
        }
        // header params
        if ($content_encoding !== null) {
            $headerParams['Content-Encoding'] = ObjectSerializer::toHeaderValue($content_encoding);
        }
        // header params
        if ($content_type !== null) {
            $headerParams['Content-Type'] = ObjectSerializer::toHeaderValue($content_type);
        }

        // path params
        if ($shard_id !== null) {
            $resourcePath = str_replace(
                '{' . 'shardID' . '}',
                ObjectSerializer::toPathValue($shard_id),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['text/plain']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            if ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($_tempBody));
            } else {
                $httpBody = $_tempBody;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
